Status: Closed Start date: 21 Jun 2012

Priority: High Due date:  

Assignee: Anna Maria Bigatti % Done: 100%

Category: Parser/Interpreter Estimated time: 0.00 hour

Target version: CoCoA-5.0.9 Spent time: 4.75 hours

Description

Can we split BuiltinFunctions.C so that it is easier to update and faster to compile?

Related issues:

Related to CoCoALib - Support #452: Documentation for adding functions to CoC... Closed 01 Mar 2014

Related to CoCoA-5 - Support #296: Documentation for Parser/Interpreter In Progress 24 Jan 2013

Related to CoCoA-5 - Design #782: BuiltinFunctions -- getting too long again! Closed 01 Oct 2015

History

#1 - 21 Jun 2012 12:26 - Anna Maria Bigatti

One proposal for splitting is

- file A: general macros and templates

- file B: all oneliners (the easy ones) with all oneliner macros (includes A)

- fiel C: all other builtin functions (includes A)

Can B and C be compiled independently? (otherwise this splitting is useless)

I think we have to make two variables vector<NameFunPair> builtIns;

for the files B and C and modify the macros accordingly, and then call in B and C the corresponding

void RuntimeEnvironment::initBuiltInFunctions()

{

    BOOST_FOREACH(NameFunPair &p, builtIns)

        this->setTopLevelVar(p.first, p.second, VariableSlot::VSF_SystemProtected);

}

#2 - 21 Jun 2012 12:39 - Giovanni Lagorio

I think we have to make two variables vector<NameFunPair> builtIns;

 

You can probably keep a single variable builtIns, but you have to make it visible in both B and C.

I didn't check, but I think that moving the declaration of NameFunPair and builtIns in A (of course, removing them from the anonymous namespace),

and defining builtIns in either B or C, should do the trick.
#3 - 04 Jul 2012 14:44 - Anna Maria Bigatti

Should we also separate builtin function from external libs?  (I think so)

if so, should we have

BuiltinFunctionsNormaliz.C, BuiltinFunctionsGSL.C, BuiltinFunctionsFrobby.C

or just

BuiltinFunctionsExternalLibs.C

#4 - 05 Jul 2012 16:35 - Anna Maria Bigatti

- Status changed from New to In Progress

- Assignee set to Anna Maria Bigatti

- Priority changed from Normal to High

- % Done changed from 0 to 30

split into 4 files:

- BuiltInFunctions.[CH]

- BuiltInOneLiners.[CH]

next step: split out functions from external libraries.

#5 - 06 Jul 2012 16:46 - Christof Soeger

During linking BuiltInOneLiners.o cannot be found.

I could have somethink to do with the name of the .C file, it has a lower case i: BuiltinOneLiners.C

#6 - 06 Jul 2012 18:19 - Anna Maria Bigatti

Fixed.

(Even on a Mac) Emacs distinguishes cases.  Just to make sure I suggest to check-out BuiltinOneLiners.C first (removed) and then

BuiltInOneLiners.C (added).

#7 - 11 Jul 2012 11:14 - Anna Maria Bigatti

- % Done changed from 30 to 60

Now there are dedicated files BuiltInFunctions-GSL and BuiltInFunctions-Normaliz for these two external libraries.

Next step would be to design a (macro?) mechanism to include anyway the "external" functions in CoCoA-5, and returning a meaningful error is the

library is not included.

#8 - 23 Jan 2013 12:44 - Anna Maria Bigatti

- Target version set to CoCoA-5.0.3

- % Done changed from 60 to 70

Splitting the code seems to work very well.

Now I wonder whether I should also split BuiltinFunctions separating the cocoa-types (list, record, ..) which are more abstract, from the cocoalib-types

(ring, ideal, ...) which are usually dealing with calling cocoalib functions depending on type.

I'm not sure it is worth it, but the nature of these functions is indeed quite different.
#9 - 31 May 2013 08:55 - Anna Maria Bigatti

- Target version changed from CoCoA-5.0.3 to CoCoA-5.0.9

#10 - 01 Aug 2013 08:10 - Anna Maria Bigatti

- Status changed from In Progress to Closed

- % Done changed from 70 to 100

The splitting works well.

There may be further refinements, but they'd better be new issues on their own.

==> closing this issue
